﻿Imports System.Drawing
Imports System.Windows.Forms

'Author: Gadget Creator

Class AeroBlack
    Inherits ProfessionalColorTable
    Public Overrides ReadOnly Property ButtonSelectedHighlight() As Color
        Get
            Return ButtonSelectedGradientMiddle
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonSelectedHighlightBorder() As Color
        Get
            Return ButtonSelectedBorder
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonPressedHighlight() As Color
        Get
            Return ButtonPressedGradientMiddle
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonPressedHighlightBorder() As Color
        Get
            Return ButtonPressedBorder
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonCheckedHighlight() As Color
        Get
            Return ButtonCheckedGradientMiddle
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonCheckedHighlightBorder() As Color
        Get
            Return ButtonSelectedBorder
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonPressedBorder() As Color
        Get
            Return ButtonSelectedBorder
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonSelectedBorder() As Color
        Get
            Return Color.FromArgb(255, 114, 114, 114)
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonCheckedGradientBegin() As Color
        Get
            Return Color.FromArgb(255, 176, 179, 179)
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonCheckedGradientMiddle() As Color
        Get
            Return Color.FromName("Black")
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonCheckedGradientEnd() As Color
        Get
            Return Color.FromName("Black")
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonSelectedGradientBegin() As Color
        Get
            Return Color.FromArgb(255, 133, 154, 165)
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonSelectedGradientMiddle() As Color
        Get
            Return Color.FromArgb(255, 3, 50, 82)
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonSelectedGradientEnd() As Color
        Get
            Return Color.FromArgb(255, 82, 167, 203)
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonPressedGradientBegin() As Color
        Get
            Return Color.FromArgb(255, 77, 77, 77)
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonPressedGradientMiddle() As Color
        Get
            Return Color.FromName("Black")
        End Get
    End Property
    Public Overrides ReadOnly Property ButtonPressedGradientEnd() As Color
        Get
            Return Color.FromName("Black")
        End Get
    End Property
    Public Overrides ReadOnly Property CheckBackground() As Color
        Get
            Return Color.FromArgb(255, 167, 167, 167)
        End Get
    End Property
    Public Overrides ReadOnly Property CheckSelectedBackground() As Color
        Get
            Return Color.FromArgb(255, 166, 166, 166)
        End Get
    End Property
    Public Overrides ReadOnly Property CheckPressedBackground() As Color
        Get
            Return Color.FromArgb(255, 166, 166, 166)
        End Get
    End Property
    Public Overrides ReadOnly Property GripDark() As Color
        Get
            Return Color.FromArgb(255, 147, 147, 147)
        End Get
    End Property
    Public Overrides ReadOnly Property GripLight() As Color
        Get
            Return Color.FromName("ControlLight")
        End Get
    End Property
    Public Overrides ReadOnly Property ImageMarginGradientBegin() As Color
        Get
            Return Color.FromArgb(255, 148, 148, 148)
        End Get
    End Property
    Public Overrides ReadOnly Property ImageMarginGradientMiddle() As Color
        Get
            Return Color.FromArgb(255, 95, 95, 95)
        End Get
    End Property
    Public Overrides ReadOnly Property ImageMarginGradientEnd() As Color
        Get
            Return Color.FromArgb(255, 42, 42, 42)
        End Get
    End Property
    Public Overrides ReadOnly Property ImageMarginRevealedGradientBegin() As Color
        Get
            Return Color.FromName("ControlLightLight")
        End Get
    End Property
    Public Overrides ReadOnly Property ImageMarginRevealedGradientMiddle() As Color
        Get
            Return Color.FromName("ControlLightLight")
        End Get
    End Property
    Public Overrides ReadOnly Property ImageMarginRevealedGradientEnd() As Color
        Get
            Return Color.FromName("Menu")
        End Get
    End Property
    Public Overrides ReadOnly Property MenuStripGradientBegin() As Color
        Get
            Return Color.FromArgb(255, 168, 168, 168)
        End Get
    End Property
    Public Overrides ReadOnly Property MenuStripGradientEnd() As Color
        Get
            Return Color.FromArgb(255, 19, 20, 21)
        End Get
    End Property
    Public Overrides ReadOnly Property MenuItemSelected() As Color
        Get
            Return Color.FromArgb(255, 74, 74, 74)
        End Get
    End Property
    Public Overrides ReadOnly Property MenuItemBorder() As Color
        Get
            Return Color.FromArgb(255, 133, 154, 165)
        End Get
    End Property
    Public Overrides ReadOnly Property MenuBorder() As Color
        Get
            Return Color.FromName("ControlDark")
        End Get
    End Property
    Public Overrides ReadOnly Property MenuItemSelectedGradientBegin() As Color
        Get
            Return Color.FromArgb(255, 133, 154, 165)
        End Get
    End Property
    Public Overrides ReadOnly Property MenuItemSelectedGradientEnd() As Color
        Get
            Return Color.FromArgb(255, 3, 50, 82)
        End Get
    End Property
    Public Overrides ReadOnly Property MenuItemPressedGradientBegin() As Color
        Get
            Return Color.FromArgb(255, 133, 154, 165)
        End Get
    End Property
    Public Overrides ReadOnly Property MenuItemPressedGradientMiddle() As Color
        Get
            Return Color.FromArgb(255, 82, 167, 203)
        End Get
    End Property
    Public Overrides ReadOnly Property MenuItemPressedGradientEnd() As Color
        Get
            Return Color.FromArgb(255, 3, 50, 82)
        End Get
    End Property
    Public Overrides ReadOnly Property RaftingContainerGradientBegin() As Color
        Get
            Return Color.FromName("Control")
        End Get
    End Property
    Public Overrides ReadOnly Property RaftingContainerGradientEnd() As Color
        Get
            Return Color.FromName("Control")
        End Get
    End Property
    Public Overrides ReadOnly Property SeparatorDark() As Color
        Get
            Return Color.FromArgb(255, 148, 148, 148)
        End Get
    End Property
    Public Overrides ReadOnly Property SeparatorLight() As Color
        Get
            Return Color.FromArgb(255, 148, 148, 148)
        End Get
    End Property
    Public Overrides ReadOnly Property StatusStripGradientBegin() As Color
        Get
            Return Color.FromName("ControlLight")
        End Get
    End Property
    Public Overrides ReadOnly Property StatusStripGradientEnd() As Color
        Get
            Return Color.FromName("Control")
        End Get
    End Property
    Public Overrides ReadOnly Property ToolStripBorder() As Color
        Get
            Return Color.FromName("ControlDark")
        End Get
    End Property
    Public Overrides ReadOnly Property ToolStripDropDownBackground() As Color
        Get
            Return Color.FromName("Silver")
        End Get
    End Property
    Public Overrides ReadOnly Property ToolStripGradientBegin() As Color
        Get
            Return Color.FromArgb(255, 168, 168, 168)
        End Get
    End Property
    Public Overrides ReadOnly Property ToolStripGradientMiddle() As Color
        Get
            Return Color.FromArgb(255, 86, 86, 86)
        End Get
    End Property
    Public Overrides ReadOnly Property ToolStripGradientEnd() As Color
        Get
            Return Color.FromArgb(255, 19, 20, 21)
        End Get
    End Property
    Public Overrides ReadOnly Property ToolStripContentPanelGradientBegin() As Color
        Get
            Return Color.FromName("AppWorkspace")
        End Get
    End Property
    Public Overrides ReadOnly Property ToolStripContentPanelGradientEnd() As Color
        Get
            Return Color.FromArgb(255, 133, 154, 165)
        End Get
    End Property
    Public Overrides ReadOnly Property ToolStripPanelGradientBegin() As Color
        Get
            Return Color.FromArgb(255, 153, 153, 153)
        End Get
    End Property
    Public Overrides ReadOnly Property ToolStripPanelGradientEnd() As Color
        Get
            Return Color.FromArgb(255, 42, 42, 42)
        End Get
    End Property
    Public Overrides ReadOnly Property OverflowButtonGradientBegin() As Color
        Get
            Return Color.FromName("ControlLightLight")
        End Get
    End Property
    Public Overrides ReadOnly Property OverflowButtonGradientMiddle() As Color
        Get
            Return Color.FromName("ControlLight")
        End Get
    End Property
    Public Overrides ReadOnly Property OverflowButtonGradientEnd() As Color
        Get
            Return Color.FromName("Control")
        End Get
    End Property
End Class